// Programa de ajuste por polinomios ortogonales
// Compilar con
// g++ -I./templates -o gnuploti_ejemplo gnuploti_ejemplo.cpp gnuplot_i_calnum.cpp
#include "gnuplot_i_calnum.h"
#include <iostream>
#include <cmath>
#include <iomanip>
#include <fstream>
#include "algebralineal.h"
using namespace std;
using namespace CALNUM;
#define SLEEP_LGTH 100 //la figura permanece 100 segundos en pantalla

//Ejemplo de uso de gnuplot_i++

int main()
{
	//Leer xmin y xmax
	double          xmin, xmax;
	cout << "Entrar xmin" << endl;
	cin >> xmin;
	cout << "Entrar xmax" << endl;
	cin >> xmax;
	int             n = 200;
	//dibujamos 200 puntos entre xmin y xmax

       	// Declaracion de los vectores de puntos
       	Vector < double >xx(n), yy(n);

	//Relleno de los vectores
       	double          h = (xmax - xmin) / n;
	xx[0] = xmin;
	yy[0] = sin(xx[0]);
	for (int i = 1; i < n; i++)
		xx[i] = xx[i - 1] + h;
	for (int i = 1; i < n; i++)
		yy[i] = sin(xx[i]);

	//Dibujo de puntos yy versus xx
		Gnuplot g1 = Gnuplot();
	g1.set_style("lines");
	g1.plot_xy(xx, yy, "funcion seno ");

	//Algunas sentencias alternativas
		// g1.set_style("points");
	//g1.set_style("errorbars");
	//g1.plot_xy(xx, error, "");
	//g1.cmd("replot \"fichero.gpl\" with errorbars");
	//g1.cmd("replot \"pol.gpl\" with errorbars");

	sleep(SLEEP_LGTH);
	//la figura permanece SLEEP_LGTH segundos

       	// Con las dos sentencias abajo la figura permanece hasta recibir un Ctrl - C
	// const sigset_t * s;
	//sigsuspend(s);

	return 0;
}
