
 /**
  *  Addition.
  */
  friend mp_complex operator+(const mp_complex&, const mp_complex&);
  
  /**
  *  Subtraction.
  */
  friend mp_complex operator-(const mp_complex&, const mp_complex&);
  
  /**
  *  Negation.
  */
  friend mp_complex operator-(const mp_complex&);
  
  /**
  *  Multiplication.
  */
  friend mp_complex operator*(const mp_complex&, const mp_complex&);
  
  /**
  *  Division.
  */
  friend mp_complex operator/(const mp_complex&, const mp_complex&);
  
  /**
  *  Equality.
  */
  friend int operator==(const mp_complex&, const mp_complex&);
  
  /**
  *  Inequality.
  */
  friend int operator!=(const mp_complex&, const mp_complex&);
  
  /**
  *  Extraction from an input stream.
  */
  friend istream& operator>>(istream& s, mp_complex& za);
  
  /**
  *  Insertion to an output stream.
  */
  friend ostream& operator<<(ostream& s, const mp_complex& za);
  
  /**
  *  Absolute value.
  */
  friend mp_real abs(const mp_complex&);
  
  /**
  *  Imaginary part.
  */
  friend mp_real aimag(const mp_complex&);
  
  /**
  *  Conjugate.
  */
  friend mp_complex conjg(const mp_complex&);
  
  /**
  *  Conversion operator to double (primitive).
  */
  friend double dble(const mp_complex& za);
  
  /**
  *  Conversion operator to int (primitive).
  */
  friend int integer(const mp_complex& za);
  
  
  /**
  *  Conversion operator to float (primitive).
  */
  friend float real(const mp_complex& za);
  
  
  /**
  *  Conversion operator to DComplex.
  */
  friend DComplex complex(const mp_complex& za);
  
  /**
  *  Conversion operator to mp_real.
  */
  friend mp_real MP_REAL(const mp_complex&);
  
  
  /**
  *  Square root.
  */
  friend mp_complex sqrt(const mp_complex&);
  
  /**
  *  Power.
  */
  friend mp_complex power(const mp_complex&, const int);

