//Ejemplo de mpfun con  JAMA y TNT
//Valores y vectores propios de una matriz de Hilbert de orden N
//compilar con
//g++ -I./templates -I./mpfun/include  -o mpfun_tnt  mpfun_tnt.cpp -L./mpfun/lib  -lmp
#include <iostream>
#include <iomanip>
#include "mpreal.h"
#include "algebralineal.h"

using namespace CALNUM;
using namespace std;

//Double sinonimo de mp_real

typedef mp_real Double;

//typedef long double Double;

int main(){


//Definicion matriz de Hilbert de orden 100
int N;

cout<<" Entrar la dimension de la matriz de Hilbert"<<endl;
cin>>N;

//Calculo del tiempo de ejecucion. Definicion cronometro Q
Stopwatch Q;

//Comienzo cronometro
Q.start();


CALNUM::Matrix<Double> A(N,N);
for (int i=0;i<N;i++)for (int j=0;j<N;j++) 
{A[i][j]=Double(1./(i+j+2));}

//descomposicion LU
CALNUM::LU<Double>  lu(A);
Matrix<Double> L(N,N);
L=lu.getL();
//cout<<"L="<<L<<endl;

Matrix<Double> U=lu.getU();
//cout<<U<<endl;

//Vector<int> p=lu.getPivot();
//cout<<"Pivote="<<p<<endl;

// Multiplicacion de L*U
Matrix<Double>NM(N,N);
NM=matmult(L,U);
//Salida de L*U-A
cout<<"L*U-A= "<<NM-A<<endl;

//Calculo del  determinamte de L*U
Double det=lu.det();
cout<<"determinante(L*U)= "<<det<<endl;


//Calculo de valores propios
Eigenvalue<Double> eig(A);
Vector<Double> aa(N);

//poner los valores propios reales en aa
eig.getRealEigenvalues(aa);

//vectores propios, se escriben en la matriz L
eig.getV(L);

//matriz diagonal, se escribe eb H
Matrix<Double> H(N,N);
H=0.;
eig.getD(H);

cout<<"Valores Propios= "<<aa<<endl;
cout<<"Vectores Propios= "<<L<<endl;
cout<<"Matriz diagonal= "<<H<<endl;


//calculo de la inversa
//Definicion de la matriz identidad XX
//inicializacion de XX a la matriz nula
Matrix<Double> XX(N,N,0.);
for (int i=0;i<N;i++) XX[i][i]=Double(1.);

// la inversa ZZ es la solucion de A*ZZ=XX;

Matrix<Double> ZZ=lu.solve(XX);

//cout<<ZZ<<endl;

//Comprobacion Inv(A)*A=I

Matrix<Double> QQ=matmult(ZZ,A);// QQ debe ser la matriz identidad.

//Incluso con long double falla miserablemente para N=20 
//con mpfun el error esta en el decimal 963

cout<<"Matriz identidad="<<QQ<<endl;

//Salida del tiempo de calculo. Parada cronometro y lectura.
Q.stop();
Double time=Q.read();
cout<<"time="<<time<<endl;

return 0;

}
