/*
*
*  Modificado por Jose Diaz (11/10/2005) para soportar el producto de escalares
*  y vectores (class Vector), y escalares y matrices (class Matrix) : 
*  s*vec, vec*s, s*mat, mat*s; el producto vec1*vec2 ha sido 
*  redefinido como producto escalar en vez de produnto elemento a elemento. 
*  Faltan por definir el operador *=  para vec y s y mat y s (vec*=s, mat*=s). 
*  Tampoco estan definidos mat1+=mat2, mat1-=mat2, mat1*=mat2, vec1+=vec2,
*  vec1-=vec2
*
* Template Numerical Toolkit (TNT): Linear Algebra Module
*
* Mathematical and Computational Sciences Division
* National Institute of Technology,
* Gaithersburg, MD USA
*
*
* This software was developed at the National Institute of Standards and
* Technology (NIST) by employees of the Federal Government in the course
* of their official duties. Pursuant to title 17 Section 105 of the
* United States Code, this software is not subject to copyright protection
* and is in the public domain. NIST assumes no responsibility whatsoever for
* its use by other parties, and makes no guarantees, expressed or implied,
* about its quality, reliability, or any other characteristic.
*
*/


#ifndef TNT_H
#define TNT_H



//---------------------------------------------------------------------
// Define this macro if you want  TNT to track some of the out-of-bounds
// indexing. This can encur a small run-time overhead, but is recommended 
// while developing code.  It can be turned off for production runs.
// 
//       #define TNT_BOUNDS_CHECK
//---------------------------------------------------------------------
//

//#define TNT_BOUNDS_CHECK



#include "tnt_version.h"
#include "tnt_math_utils.h"
#include "tnt_stopwatch.h"
#include "tnt_subscript.h"
#include "tnt_vec_calnum.h"
#include "tnt_cmat_calnum.h"
#include "jama_lu_calnum.h"
#include "jama_cholesky_calnum.h"
#include "jama_eig_calnum.h"
#include "jama_qr_calnum.h"
#include "jama_svd_calnum.h"



#endif
// TNT_H
