 /**
   *  Addition.
   */
  friend mp_real operator+(const mp_real& ja, const mp_real& jb);
  
  /**
   *  Subtraction.
   */
  friend mp_real operator-(const mp_real& ja, const mp_real& jb);
  
  /**
   *  Negation.
   */
  friend mp_real operator-(const mp_real& ja);
  
  /**
   *  Multiplication.
   */
  friend mp_real operator*(const mp_real& ja, const mp_real& jb);
  
  /**
   *  Division.
   */
  friend mp_real operator/(const mp_real& ja, const mp_real& jb);
 /**
   *  Absolute value.
   */
  friend mp_real abs(const mp_real&);
  
  /**
   *  Maximum.
   */
  friend mp_real maximum(const mp_real&, const mp_real&);
  
  /**
   *  Minimum.
   */
  friend mp_real minimum(const mp_real&, const mp_real&);
  
  /**
   *  FORTRAN's sign operator.
   *  @return The absolute value of first parameter with sign of 
   *  second parameter.
   */
  friend mp_real sign(const mp_real&, const mp_real&);
  
  /**
   *  Power.
   */  
  friend mp_real power(const mp&, const mp&);
  
  /**
   *  Power.
   */
  friend mp_real power(const int, const mp_real&);
  
  /**
   *  Power.
   */
  friend mp_real power(const mp_real&, const int);
  
  /**
   *  Power.
   */
  friend mp_real power(const double, const mp&);
  
  /**
   *  Power.
   */
  friend mp_real power(const mp&, const double);
  
  /**
   *  Arccosine.
   */
  friend mp_real acos(const mp_real&);
  
  /**
   *  Truncation to whole number.
   */
  friend mp_real aint(const mp_real&);
  
  /**
   *  Nearest whole number.
   */
  friend mp_real anint(const mp_real&);
  
  /**
   *  Arcsine.
   */
  friend mp_real asin(const mp_real&);
  
  /**
   *  Arctangent.
   */
  friend mp_real atan(const mp_real&);
  
  /**
   *  Arctangent of y/x.
   */
  friend mp_real atan2(const mp_real&, const mp_real&);
  
  /**
   *  Cosine.
   */
  friend mp_real cos(const mp_real&);
  
  /**
   *  Hyperbolic Cosine.
   */
  friend mp_real cosh(const mp_real&);
  
  /**
   *  Exponential.
   */
  friend mp_real exp(const mp_real&);
  
  /**
   *  Natural Logarithm.
   */
  friend mp_real log(const mp_real&);
  
  /**
  *  Common Logarithm (base 10).
  */
  friend mp_real log10(const mp_real&);
  
  /**
   *  Hyperbolic cosine and sine.
   */
  friend void mpcsshf(const mp_real&, mp_real&, mp_real&);
  
  /**
   *  Cosine and sine.
   */
  friend void mpcssnf(const mp_real&, mp_real&, mp_real&);
  
  /**
  *  N-th root.
  */
  friend mp_real mpnrtf(const mp_real&, int);
  
  /**
   *  Returns a pseudo-random mp_real number between 0 and 1.
   */
  friend mp_real mp_rand();
  
  /**
   *  Nearest integer.
   */
  friend mp_int nint(const mp_real&);
  
  /**
   *  Sine.
   */
  friend mp_real sin(const mp_real&);
  
  /**
   *  Hyperbolic sine.
   */  
  friend mp_real sinh(const mp_real&);
  
  /**
   *  Square root.
   */  
  friend mp_real sqrt(const mp_real&);
  
  /**
   *  Tangent.
   */
  friend mp_real tan(const mp_real&);
  
  /**
   *  Hyperbolic tangent.
   */
  friend mp_real tanh(const mp_real&);
